package dev.pfaff.altargui.widgets;

import dev.pfaff.altargui.*;
import dev.pfaff.altargui.element.Painter;
import dev.pfaff.altargui.render.objects.RectRenderObject;
import dev.pfaff.altargui.types.Color;
import org.jetbrains.annotations.NotNull;

// TODO: optimize
public record ProgressBarWidget() implements Widget {
	public static final ProgressBarWidget DEFAULT = new ProgressBarWidget();

	@Override
	public @NotNull WidgetInstance instantiate(WidgetInstantiationArgs args) {
		return new State(args);
	}

	private static final class State extends WidgetInstance<ProgressBarWidget> implements Painter {
		private final RectRenderObject background = new RectRenderObject();
		private final RectRenderObject fill = new RectRenderObject();

		private State(WidgetInstantiationArgs args) {
			super(args);
			background.updateColor(RectWidget.GENERIC_HUD_BACKGROUND.color());
			fill.updateColor(Color.fromRgba(0x76f66f_ee));
		}

		@Override
		public void configure(StateContext stateContext, ProgressBarWidget widget, boolean init) {
		}

		@Override
		protected void computeStencilLayout(StateContext context) {
			computeFillLayout(this);
			this.background.updateSize(computedWidth(), computedHeight());
		}

		@Override
		protected void computeTraceLayout() {
			this.background.updatePosition(allocatedX(), allocatedY());
		}

		@Override
		protected void computeMount(MountContext context) {
		}

		@Override
		public void uSpecMount(MountContext context) {
			super.uSpecMount(context);
		}

		@Override
		public void paint(long time, Canvas canvas) {
			float x1 = allocatedX();
			float y1 = allocatedY();
			float width = computedWidth();
			float height = computedHeight();
			float f = (time % 1500L) / 1500.0f;
			float offX = width * f;
			float len = width * 0.3f * Math.abs((float) Math.sin(time * (Math.PI / 1500f)))
					- width * 0.1f * (float) Math.sin(time * (Math.PI / 1500f));
			fill.updatePositionSize(x1 + offX, y1, Math.min(len, width - offX), height);
			canvas.upload(background);
			canvas.upload(fill);
		}
	}
}
